#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>

#define TASKNAME "cycles"

const int MaxN = 10000, NA = -1;

int p [MaxN], q [MaxN];
bool b [MaxN];
int n, k;

int main (void)
{
 int i, j;
 freopen (TASKNAME ".in", "rt", stdin);
 freopen (TASKNAME ".out", "wt", stdout);
 while (scanf (" %d", &n) != EOF)
 {
  assert (1 <= n && n <= MaxN);
  for (i = 0; i < n; i++)
  {
   scanf (" %d", &p[i]);
   assert (1 <= p[i] && p[i] <= n);
   p[i]--;
  }
  memset (q, NA, sizeof (q));
  for (i = 0; i < n; i++)
   q[p[i]] = i;
  for (i = 0; i < n; i++)
   assert (q[i] != NA);
  memset (b, 0, sizeof (b));
  for (i = 0; i < n; i++) if (!b[i])
  {
   if (i) printf (" ");
   printf ("(%d", i + 1);
   b[i] = true;
   for (j = p[i]; j != i; j = p[j])
   {
    printf (" %d", j + 1);
    b[j] = true;
   }
   printf (")");
   i = p[j];
  }
  printf ("\n");
 }
 return 0;
}
