#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>

#define TASKNAME "chocolat"
typedef long long int64;

const int MaxN = 1000000000;

int n, k;

int main (void)
{
 freopen (TASKNAME ".in", "rt", stdin);
 freopen (TASKNAME ".out", "wt", stdout);
 while (scanf (" %d %d", &n, &k) != EOF)
 {
  assert (1 <= n && n <= MaxN);
  assert (1 <= k && k <= MaxN);
  int64 a, b, c, d, res;
  d = k;
  a = n % d;
  b = (n + 1) % d;
  c = (2 * int64 (n) + 1) % d;
  if (!(a % 2)) a /= 2;
  else if (!(b % 2)) b /= 2;
  else if (!(c % 2)) c /= 2;
  else assert (false);
  if (!(a % 3)) a /= 3;
  else if (!(b % 3)) b /= 3;
  else if (!(c % 3)) c /= 3;
  else assert (false);
  a = (a * b) % d;
  res = (a * c) % d;
  printf ("%d\n", (int) res);
 }
 return 0;
}
